/**
 * Structure for storing data in the program
 * 
 * @author zimon
 */
public class StayOnlineData {
    
    private String user;
    private String sid;
    private String text;
    private String server;
    private String chat;
    private int time;
    private boolean close;
    public static String VER = "0.1.3";
    
    /**
     * Calls setZero() that sets all strings to ""
     */
    public StayOnlineData() {
        setZero();
    }
    
    /**
     * Sets all Strings to "" and time to 900
     */
    public void setZero() {
        user = "";
        sid = "";
        text = "";
        server = "";
        chat = "";
        time = 900;
        close = false;
    }
    
    /**
     * @return the chat
     */
    public String getChat() {
        return chat;
    }
    
    /**
     * @param chat the chat to set
     */
    public void setChat(String chat) {
        this.chat = chat;
    }
    
    /**
     * @return the server
     */
    public String getServer() {
        return server;
    }
    
    /**
     * @param server the server to set
     */
    public void setServer(String server) {
        this.server = server;
    }
    
    /**
     * @return the sid
     */
    public String getSid() {
        return sid;
    }
    
    /**
     * @param sid the sid to set
     */
    public void setSid(String sid) {
        this.sid = sid;
    }
    
    /**
     * @return the text
     */
    public String getText() {
        return text;
    }
    
    /**
     * @param text the text to set
     */
    public void setText(String text) {
        this.text = text;
    }
    
    /**
     * @return the time
     */
    public int getTime() {
        return time;
    }
    
    /**
     * @return the time as String
     */
    public String getTimeString() {
        return Integer.toString(time);
    }
    
    /**
     * @param time the time to set
     */
    public void setTime(int time) {
        this.time = time;
    }
    
    /**
     * @return the user
     */
    public String getUser() {
        return user;
    }
    
    /**
     * @param user the user to set
     */
    public void setUser(String user) {
        this.user = user;
    }
    
    /**
     * @return the close
     */
    public boolean isClose() {
        return close;
    }
    
    /**
     * @param closeOnExit the closeOnExit to set
     */
    public void setClose(boolean close) {
        this.close = close;
    }
    
    /**
     * @return Stringrepresentation off "close on exit" status
     */
    public String getCloseString() {
        if(close == true) {
            return "true";
        } else {
            return "false";
        }
    }
    
    /**
     * Sets the Parameter for "close on exit"
     * 
     * @param s stringrepresentation of status
     */
    public void setCloseString(String s) {
        if(s.equals("true")) {
            close = true;
        } else {
            close = false;
        }
    }
    
}
