import java.awt.GridLayout;
import java.awt.event.*;
import javax.swing.*;

/**
 * GUI of the Options-Window
 */
public class StayOnlineOptGui extends JFrame implements ActionListener, WindowListener {
    
    static final long serialVersionUID = 1L;
    StayOnlineData data;
    StayOnlineGui gui;
    
    JTextField tfMBoxLink;
    JTextField tfText;
    JTextField tfTime;
    JCheckBox cbClose;
    
    JButton bOk;
    JButton bAbort;
    
    /**
     * Sets all graphical components
     */
    public StayOnlineOptGui(StayOnlineData data, StayOnlineGui gui) {
        super("StayOnline - Einstellungen");
        this.data = data;
        this.gui = gui;
        setSize(350, 200);
        GridLayout grid = new GridLayout(5, 2);
        
        JPanel pMain = new JPanel(grid);
        
        JLabel lMBoxLink = new JLabel("Link zur MesageBox");
        tfMBoxLink = new JTextField("http://"+data.getServer()+".webkicks.de/"+data.getChat()+"/gate/"+data.getUser()+"/"+data.getSid()+"/pmframe", 10);
        
        JLabel lText = new JLabel("Text");
        tfText = new JTextField(data.getText(), 10);

        JLabel lTime = new JLabel("Zeit in s");
        tfTime = new JTextField(data.getTimeString(), 30);
        
        JLabel lClose = new JLabel("bei Logout schließen");
        cbClose = new JCheckBox();
        cbClose.setSelected(data.isClose());
        
        bOk = new JButton("OK");
        bAbort = new JButton("Abbrechen");
        
        bOk.addActionListener(this);
        bAbort.addActionListener(this);
        addWindowListener(this);
        
        pMain.add(lMBoxLink);
        pMain.add(tfMBoxLink);;
        pMain.add(lText);
        pMain.add(tfText);
        pMain.add(lTime);
        pMain.add(tfTime);
        pMain.add(lClose);
        pMain.add(cbClose);
        pMain.add(bOk);
        pMain.add(bAbort);
        
        setContentPane(pMain);
        setVisible(true);
    }
    
    public void windowClosing(WindowEvent event) {
        bAbortPressed();
    }
    
    public void windowClosed(WindowEvent event) {
    }
    
    public void windowDeiconified(WindowEvent event) {
    }
    
    public void windowIconified(WindowEvent event) {
    }
    
    public void windowActivated(WindowEvent event) {
    }
    
    public void windowDeactivated(WindowEvent event) {
    }
    
    public void windowOpened(WindowEvent event) {
    }
    
    /**
     * Handles actionEvents from Buttons
     */
    public void actionPerformed(ActionEvent evt) {
        
        Object src = evt.getSource();
        if(src == bOk) {
            bOkPressed();
        } else if(src == bAbort) {
            bAbortPressed();
        } else
            System.out.println("keinen knopf gedrueckt");
        repaint();
    }
    
    /**
     * If Ok is pressed this function is called. It saves the settings into data-structure and file and returns to main
     * GUI
     */
    public void bOkPressed() {
        getData();
        StayOnlineRw.saveSettings(data);
        gui.setText(data.getText());
        gui.setTime(data.getTimeString());
        this.dispose();
    }
    
    /**
     * Is called when bAbort is pressed. Returns to the main GUI without saving
     */
    public void bAbortPressed() {
        this.dispose();
        
    }
    
    /**
     * Sets the values of the textFields into data-structure
     */
    void getData() {
    	String lnk = tfMBoxLink.getText().substring(7);
    	String[] lnkVal = lnk.split("/");
    	
        data.setUser(lnkVal[3]);
        data.setSid(lnkVal[4]);
        data.setText(tfText.getText());
        data.setServer(lnk.substring(0,7));
        data.setChat(lnkVal[1]);
        data.setTime(Integer.parseInt(tfTime.getText()));
        if(cbClose.getSelectedObjects() == null) {
            data.setClose(false);
        } else {
            data.setClose(true);
        }
    }
}