import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

/**
 * File operations to save and load settings
 */
public class StayOnlineRw {
    
    /**
     * Saves all Settings in the file "data.txt"
     * 
     * @param data StayOnlineDataV011
     * @return 1 for finished and 0 for failure
     */
    public static int saveSettings(StayOnlineData data) {
        try {
            BufferedWriter out = new BufferedWriter(new FileWriter("data.txt"));
            out.write(data.getUser());
            out.newLine();
            out.write(data.getSid());
            out.newLine();
            out.write(data.getText());
            out.newLine();
            out.write(data.getServer());
            out.newLine();
            out.write(data.getChat());
            out.newLine();
            out.write(data.getTimeString());
            out.newLine();
            out.write(data.getCloseString());
            out.close();
            return 1;
        }
        catch(Exception e) {
            System.out.println("Fehler beim Schreiben");
            return 0;
        }
        
    }
    
    /**
     * Loads settings from "data.txt"
     * 
     * @param data StayOnlineDataV011 to fill with data
     * @return 1 for finished and 0 for failure
     */
    public static int loadSettings(StayOnlineData data) {
        try {
            BufferedReader in = new BufferedReader(new FileReader("data.txt"));
            String line;
            line = in.readLine();
            data.setUser(line);
            line = in.readLine();
            data.setSid(line);
            line = in.readLine();
            data.setText(line);
            line = in.readLine();
            data.setServer(line);
            line = in.readLine();
            data.setChat(line);
            line = in.readLine();
            data.setTime(Integer.parseInt(line));
            line = in.readLine();
            System.out.println(line);
            data.setCloseString(line);
            
            in.close();
            return 0;
        }
        catch(Exception e) {
            System.out.println("Fehler beim Lesen der Datei");
            return 1;
        }
        
    }
}
