import java.net.*;
import java.io.*;
import java.lang.Thread;

/**
 * Implements functions to generate and send the data to Webkicks
 * 
 * @author zimon
 */
public class StayOnlineSend extends Thread {
    StayOnlineData data;
    StayOnlineGui gui;
    
    public boolean count = true;
    
    /**
     * Starts the sending thread
     * 
     * @param data the array of Strings with required values
     */
    public StayOnlineSend(StayOnlineData data, StayOnlineGui gui) {
        this.data = data;
        this.gui = gui;
        start();
    }
    
    /**
     * Stops the sending thread
     */
    public void halt() {
        count = false;
    }
    
    /**
     * continues the sending thread
     */
    public void continueSending() {
        count = true;
    }
    
    /**
     * sending thread with waiting functionality Waits number of seconds then sends alive String
     */
    public void run() {
        
        int zeit = data.getTime();
        int x = 0;
        String temp = data.getText();
        data.setText("/f " + data.getUser() + " Willkommen bei StayOnline Version "+StayOnlineData.VER);
        sendAlive(replace(0));
        data.setText(temp);
        while(count) {
            x++;
            try {
                for(int z = 0; (z < zeit) && (count == true); z++) {
                    gui.setTime(Integer.toString(zeit - z));
                    Thread.sleep(1000); // Sleep 1 second
                }
                if(count == false) {
                    break;
                }
                gui.setTime("0");
                data.setText(gui.getText());
                String text = replace(x);
                System.out.println(text);
                sendAlive(text);
                
            }
            catch(InterruptedException e) {
            };
        }
    }
    
    /**
     * Replaces the variables in the String that should be send
     * 
     * @param i number of alivestrings send
     * @return String with replaced values
     */
    public String replace(int i) {
        String t = data.getText();
        String n = "";
        
        for(int x = 0; x < t.length(); x++) {
            if(t.charAt(x) == '$' && t.charAt(x + 1) == 'c' && t.charAt(x + 2) == 'n' && t.charAt(x + 3) == 't') {
                n = n + Integer.toString(i);
                x = x + 3;
            } else if(t.charAt(x) == '$' && t.charAt(x + 1) == 'v' && t.charAt(x + 2) == 'e' && t.charAt(x + 3) == 'r') {
                n = n.concat(StayOnlineData.VER);
                x = x + 3;
            } else if(t.charAt(x) == '$' && t.charAt(x + 1) == 'u') {
                n = n.concat(data.getUser());
                x = x + 1;
            } else if(t.charAt(x) == ' ') {
                n = n + '+';
            } else {
                n = n + t.charAt(x);
            }
        }
        return n;
    }
    
    /**
     * Handles the connections and sends the String
     * 
     * @param t the String to be send
     */
    private void sendAlive(String t) {
        try {
            URL chaturl = new URL("http://" + data.getServer() + ".webkicks.de/cgi-bin/chat.cgi?user=" + data.getUser()
                    + "&pass=" + data.getSid() + "&cid=" + data.getChat() + "&message=" + t + "&s=CHAT");
            BufferedReader in = new BufferedReader(new InputStreamReader(chaturl.openStream()));
            while((in.readLine()) != null)
                in.close();
        }
        catch(MalformedURLException e) {
            System.out.println("URL-Fehler: " + e);
        }
        catch(IOException f) {
            if(data.isClose()) {
                System.exit(0);
            }
        }
        
    }
}
